use strict;
use warnings;
use Getopt::Long;

#------------- Valeurs par defaut des options ------------------------------
my %params;
$params{'out'} = "";
$params{'in'} = "";

#-----------------------------------------------------------------------------
my $DESCRIPTION =
  "\nMet un paragraphe par ligne.\n";

my $USAGE =
  "Usage: perl $0 -out file <files>\n"
    ."\t-in file : fichier a convertir [par defaut $params{'in'}]\n"
    ."\t-out file : fichier converti [par defaut $params{'out'}]\n"
    ."\t-help : pour afficher cette aide\n";


if ( grep($_ eq "--help" || $_ eq "-help", @ARGV)) { die $DESCRIPTION . "\n" . $USAGE . "\n"; }

# ------------- lecture des parametres et Options-----------------------------
&GetOptions ('out=s' => \$params{'out'},
             'in=s' => \$params{'in'},
             'help|?|h' => \$params{'help'});

if ($params{'help'}) { die $DESCRIPTION . "\n" . $USAGE . "\n"; }

if ($params{'in'} eq "") { die $DESCRIPTION . "\n" . $USAGE . "\n"; }
if ($params{'out'} eq "") {
    $params{'out'} = $params{'in'};
    $params{'out'} .= '.convert';
}

#-----------------------------------------------------------------------------
open (F, $params{'in'}) or die ();
open (S, "> $params{'out'}") or die ();

my $line = "";
my $is_empty = 0;
my $paragraph = "";

while ($line = <F>) {
    chomp ($line);
    $is_empty = ($line =~ /^ *$/);
    
    if ($is_empty) {
        if ($paragraph) {
            chop $paragraph;
            print S $paragraph . "\n\n";
            $paragraph = "";
        }
        next;
    
    } else {
        $paragraph .= $line . " ";
    }
}

chop $paragraph;
print S $paragraph;

close (S);
close (F);
