use strict;
use warnings;

use Getopt::Long;
#------------- Valeurs par defaut des options ------------------------------
my %params;

$params{'random'} = 5;
$params{'out'} = "";
$params{'in'} = "";

# ------------------------------------------------------------------------------
my ($year, $line, $file, $first_line, $subline, $local_line);
my (%abreviations);

# ------------------------------------------------------------------------------

my $DESCRIPTION =
  "\nSelectionne un pourcentage de lignes dans un fichier.\n";

my $USAGE =
  "Usage: perl $0 -out file <files>\n"
    ."\t-p int : pourcentage de lignes a retenir [par defaut $params{'random'}%]\n"
    ."\t-in file : fichier contenant les lignes a selectionner [par defaut $params{'in'}]\n"
    ."\t-out file : fichier obtenu apres selection des lignes [par defaut $params{'out'}]\n"
    ."\t-clean : supprime les fichiers crees\n"
    ."\t-help : pour afficher cette aide\n";


if ( grep($_ eq "--help" || $_ eq "-help", @ARGV)) { die $DESCRIPTION . "\n" . $USAGE . "\n"; }

# ------------- lecture des parametres et Options ------------------------------

&GetOptions ('out=s' => \$params{'out'},
             'in=s' => \$params{'in'},
             'p=i' => \$params{'random'},
             'clean' => \$params{'clean'},
             'help|?|h' => \$params{'help'});

if ($params{'help'}) { die $DESCRIPTION . "\n" . $USAGE . "\n"; }

if ($params{'clean'}) {
    system ("\\rm -rf $params{'out'}");
    exit;
}

if ($params{'in'} eq "") { die $DESCRIPTION . "\n" . $USAGE . "\n"; }
if ($params{'out'} eq "") {
    $params{'out'} = $params{'in'};
    $params{'out'} .= '.select.'.$params{'random'};
}

# ------------------------------------------------------------------------------

my (@data, @index);
open (F, $params{'in'}) or die ();

my $nb_exemples = 0;
@data = @index = ();

while ($line = <F>) {
    chomp ($line);
    # analyse des donnees
    push (@data, $line);
    push (@index, $nb_exemples);
    $nb_exemples++;
}
close (F);

open (S, "> $params{'out'}") or die ();
my $nb_select = int ($nb_exemples * $params{'random'} / 100);
my $i;
while ($nb_select > 0) {
    $i = int (rand ($#index + 1));
    print S $data[$index[$i]]."\n";
    $data[$index[$i]] = "####";
    splice (@index, $i, 1); 
    $nb_select --;
}

close (S);
